#include <inttypes.h>
#include <avr/io.h>
#include <stdio.h>
#include <stdlib.h>

typedef uint8_t BYTE;
typedef uint16_t LBYTE;
#define UART0_UBR 51	// 9600 Baud

#define SRAM __attribute__((section(".noinit")))

uint16_t br;
uint16_t la[2000] SRAM;


void usart0_init(void);
void usart0_sendByte(BYTE data);
int uart_putchar(char c);

int main(void)
{
	LBYTE cntr =0;
  	LBYTE temp =0;
  	
  	usart0_init();
	uart_putchar(62);
	
	DDRC = 0xFF;
	PORTC = 0x00;
	MCUCR |=(1<<SRE);
	
	fdevopen(uart_putchar,NULL,0);
	
	//array fllen
	for(LBYTE i=0;i<1999;i++){la[i]=i;}
  	//und auslesen ohne anfngliches Steuerzeichen-gelumpe
  	//for(LBYTE i=32;i<1999;i++){temp= la[i];usart0_sendByte(temp>>8);usart0_sendByte((temp));}
  	
  
  while(1){
   	//anfang des Arrays
   	la[0]= 0x2223;			// " #
  	temp =la[0]; 			
  	BYTE lese_up = (temp>>8);uart_putchar(lese_up);
  	BYTE lese_dn = temp;	 uart_putchar(lese_dn);
   	
   	//diese Zeilen zum Test ob Ende des Arrays erreichbar , wenn Gre int. RAM berschreitet um elektr. Fehler auszuschlieen
	la[1997]=0x1053;temp = la[1997];usart0_sendByte(temp>>8);usart0_sendByte((temp));
	la[1998]=0x5441;temp = la[1998];usart0_sendByte(temp>>8);usart0_sendByte((temp));
	la[1999]=0x5254;temp = la[1999];usart0_sendByte(temp>>8);usart0_sendByte((temp));	//alle 
	
	uart_putchar(32);		// Space
   	uart_putchar(62);		// >
     	
	temp = la[cntr];		//Low_byte anteil
	usart0_sendByte(temp);
	printf("L: %d ",temp);	 	
	temp/=256;			//high_byte anteil
	usart0_sendByte(temp);
	printf("L: %d ",temp);
	
	
	if(cntr<=2000)cntr++;else cntr =0;
	
	usart0_sendByte('\r');  
	usart0_sendByte('\n');
}

return 0;
}


void usart0_init()
{
	#define UART0_UBR 51		
 	//9600 BAUD
  	UBRR0H = (BYTE)(UART0_UBR>>8);
  	UBRR0L = (BYTE)(UART0_UBR);
  	UCSR0C = (3<<UCSZ00);
  	UCSR0B = (1<<RXEN0)|(1<<TXEN0);
}

void usart0_sendByte(BYTE data)
{
  	loop_until_bit_is_set(UCSR0A,UDRE0);
  	UDR0 = data; 
}

int uart_putchar(char c)
{
	loop_until_bit_is_set(UCSR0A,UDRE0);
	UDR0 = c;
return 0;
}